/*
 * Mailbox con memoria dinamica
 */

#include <all.h>

const int NMESG = 5;
const int MSG_SIZE = 80;

extern natl mailbox_piena;
extern natl mailbox_vuota;

extern natl scrittore1;

extern natl scrittore2;

extern natl lettore;
struct mess {
	int mittente;
	char corpo[MSG_SIZE];
};

mess mailbox;

char tmpbuf[2][MSG_SIZE];
void pms(natq a)
{
	for (int i = 0; i < NMESG; i++) {
		ceread_n(0, tmpbuf[a], MSG_SIZE);
		sem_wait(mailbox_vuota);
		memcpy(mailbox.corpo, tmpbuf[a], MSG_SIZE);
		mailbox.mittente = a;
		sem_signal(mailbox_piena);
		delay(20);
	}
	printf("fine scrittore %lu\n", a);

	terminate_p();
}
void pml(natq a)
{
	char corpo[MSG_SIZE];
	int mittente;
	for (int i = 0; i < 2 * NMESG; i++) {
		sem_wait(mailbox_piena);
		mittente = mailbox.mittente;
		memcpy(corpo, mailbox.corpo, MSG_SIZE);
		sem_signal(mailbox_vuota);
		printf("messaggio %d da %d:\n", i, mittente);
		writeconsole(corpo, MSG_SIZE);
	}
	printf("fine lettore\n");
	pause();

	terminate_p();
}
natl mailbox_piena;
natl mailbox_vuota;
natl scrittore1;
natl scrittore2;
natl lettore;

extern "C" void main()
{
	mailbox_piena = sem_ini(0);
	mailbox_vuota = sem_ini(1);
	scrittore1 = activate_p(pms, 0, 5, LIV_UTENTE);
	scrittore2 = activate_p(pms, 1, 5, LIV_UTENTE);
	lettore = activate_p(pml, 0, 5, LIV_UTENTE);

	terminate_p();
}
